/*
 * @Description:拆分和合并耦合的组件
 * @Date: 2022-08-02 17:49:44
 * @LastEditors: Li Dong
 * @LastEditTime: 2022-08-06 09:37:35
 * @FilePath: \joymed\admin\src\components\FormDesign\utils\couplingCom.js
 */

import { layoutList } from '../config/formItemConfig'
import { cloneDeep } from 'lodash'

//拆分
export const splitCom = formList => {
  const formListClone = cloneDeep(formList)

  const list = layoutList.map(item => item.mode)

  recursion(formListClone)

  function recursion(recList, key = 0) {
    console.log(formListClone)
    const comtIndex = formListClone?.slice(key).findIndex(item => list.includes(item.mode))
    console.log(comtIndex)
    if (comtIndex > -1) {
      //在layoutList中的组件拆分打上标识
      recList[comtIndex]?.settings?.list?.forEach((item, index) => {
        item.forEach(element => {
          element.settings.key = recList[comtIndex]?.key + index
        })
      })
      const specialCom = recList[comtIndex]?.settings?.list.flat(1)

      const listKey = recList[comtIndex]?.settings?.list.map(
        (item, index) => recList[comtIndex]?.key + index
      )
      recList[comtIndex].settings.list = listKey

      specialCom.unshift(recList[comtIndex])

      recList.splice(comtIndex, 1, ...specialCom)

      const recKey = key + specialCom.length + 1

      recursion(recList, recKey)
    }
  }
  return formListClone
}

//组合
export const mergeCom = formList => {
  console.log(formList)
  const formListClone = cloneDeep(formList)

  const list = layoutList.map(item => item.mode)

  recursion(formListClone)

  function recursion(recList, key = 0) {
    const comtIndex = formListClone?.slice(key).findIndex(item => list.includes(item.mode))

    if (comtIndex > -1) {
      let listArr = []
      recList[comtIndex]?.settings?.list.forEach((item, index) => {
        listArr[index] = formListClone.filter(e => e.settings.key === item)
      })
      console.log(recList[comtIndex])
      recList[comtIndex].settings.list = listArr
      recursion(recList, comtIndex + 1)
    }
  }

  return formListClone.filter(e => !e.settings?.key)
}
